<?php
// This source originated from Hackadellic's TOC plugin
if ( !defined('ABSPATH') )
	exit("Sorry, you are not allowed to access this page directly.");
if ( !isset($this) || !is_a($this, wpGalleryAndCaption) )
	exit("Invalid operation context.");

$sections = array(
	(object) array(
		'title' => 'Caption Group Defaults',
		'help' => 'Fill in the desired defaults for the following options.  You can override these within the shortcode itself by specifying them directly.',
		'options' => array(
			(object) array(
				'title' => 'Columns',
				'key' => 'DEF_COLS',
				'help' => 'The default number of columns for a captiongroup (columns)'),
			(object) array(
				'title' => 'CSS Class',
				'key' => 'DEF_STYLE', 
				'help' => 'The default CSS class for the container (galleryAndCaptionContainer).' ),
		)),
		
	(object) array(
		'title' => 'Zoom Preferences',
		'help' => 'These settings change global behaviors.',
		'options' => array(
			(object) array(
				'title' => 'Shadow Size',
				'key' => 'GBL_SHADOW',
				'help' => 'Size in pixels of a small light shadow around the zoomed image.' ),
			(object) array(
				'title' => 'Border Size',
				'key' => 'GBL_BORDER', 
				'help' => 'Size in pixels of border around zoomed image.' ),
			(object) array(
				'title' => 'Zoom To Center',
				'key' => 'GBL_CENTERED',
				'style' => 'max-width: 5em',
				'text' => 'Image will zoom to center of browser, or zoom in place',
				'help' => 'You can configure the zooming to steer towards the center of the browser / view, or have the image enlarge in-place.' ),	
			(object) array(
				'title' => 'Overlay Opacity',
				'key' => 'GBL_CHROME_OPACITY', 
				'help' => 'Set the amount of opacity with a number between [0-1] of the button overlay when an image is zoomed. 0 = completely transparent, 1 = fully opaque.' ),
			(object) array(
				'title' => 'Overlay Controls',
				'key' => 'GBL_CTRLS_MOUSEOVER', 
				'style' => 'max-width: 5em',
				'text' => 'Image buttons only on mouseover',				
				'help' => 'If checked, the navigation and caption controls overlayed on the zoomed image will be removed if mouse rolls away.' ),
			(object) array(
				'title' => 'Show Navigation Controls',
				'key' => 'GBL_SHOWNAV', 
				'style' => 'max-width: 5em',
				'text' => 'Render next/prev image navigation buttons',				
				'help' => 'If checked, the navigation controls will be shown to the user.' ),	
			(object) array(
				'title' => 'Zoom Animation',
				'key' => 'GBL_ZOOMFX', 
				'pick' => (object)array('Tear Away', 'Glass Fade'),
				'help' => 'Choose the animation effect you want.  Play with each available option to find the one you like best.' ),							
		)),	
		
	(object) array(
		'title' => 'Editor Settings',
		'help' => 'Choose options related to your blog editor.',
		'options' => array(
			(object) array(
				'title' => 'CaptionGroup button',
				'key' => 'GBL_GROUPBUTTON',
				'style' => 'max-width: 5em',
				'text' => 'Add helper button to HTML editor',
				'help' => 'If checked, a button for inserting captiongroups is added to your editor.  Select the caption items you want to group and click on this button to group them.'),
		)),			
	);

?>
<?php // ------------------------------------------------------------------------------------ ?>
<style type="text/css">
<?php
	$R = '3px';
	$sideWidth = '13em';
?>
a.button { display: inline-block; margin: 5px 0 }

dl { padding: 0; margin: 10px 1em 20px 0; background-color: white; border: 1px solid #ddd; }
dt { font-size: 10pt; font-weight: bold; margin: 0; padding: 4px 10px 4px 10px;
	background: #dfdfdf url(<?php echo admin_url('images/gray-grad.png') ?>) repeat-x left top;
}
dd { margin: 0; padding: 10px 20px 10px 20px }
dl {<?php foreach (array('-moz-', '-khtml-', '-webkit-', '') as $pfx) echo " {$pfx}border-radius: $R;" ?> }

dd .caveat { font-weight: bold; color: #C00; text-align: center }

.box { border: 1px solid #ccc; padding: 5px; margin: 5px }
.help { background-color: whitesmoke }

</style>
<?php // ------------------------------------------------------------------------------------ ?>
<div class="wrap">
<div id="icon-options-general" class="icon32"><br /></div>
<h2>Gallery And Caption by dyerware</h2>

<?php
include 'dyerware-adm.php';
$helpicon = 'http://www.dyerware.com/images/inspector.png';
?>

<?php // ------------------------------------------------------------------------------------ ?>
<?php if ($updated) : ?>
<div class="updated fade"><p>Plugin settings <?php echo ($status == 'reset') ? 'reset to default values and deleted from database. If you want to, you can safely remove the plugin now' : 'saved' ?>.</p></div>
<?php endif ?>

<?php // ------------------------------------------------------------------------------------ ?>
<?php if ( $updated && $status == 'reset') : ?>

<p class="submit" align="center">
	<a class="button" href="<?php echo $actionURL ?>">Back To Settings ...</a>
</p>

<?php // ------------------------------------------------------------------------------------ ?>
<?php else: ?>

<form method="post">
	<input type="hidden" name="action" value="update" />
	<?php wp_nonce_field($context); ?>

<?php foreach ($sections as $s) : $snr += 1; $shlpid = "shlp-$snr" ?>
<dl>
	<dt><?php echo $s->title ?><?php 
	if ($s->help) :
		?> <a href="javascript:;" onclick="jQuery('#<?php echo $shlpid ?>').slideToggle('fast')"><img src="<?php
			echo $helpicon ?>" /></a><?php
	endif ?></dt>
	<dd>
<?php if ($s->help) : ?>
	<div id="<?php echo $shlpid ?>" class="hidden help box"><?php echo $s->help ?></div>
<?php endif ?>

	<table class="form-table" style="clear:none">
<?php foreach ($s->options as $o) :
	$key = $o->key;
	$v = $options->$key; $t = gettype($v);

	$style = $o->style ? " style=\"$o->style;" : 'style="width:100%;';
	if ($o->class == 'dyerware-color')
	{
	   $style .= " background-color:" . $v . ";"; 
	}	
	$style .= '"';
	
	$name = ' name="'.$key.'"';
	$class = $o->class ? " class=\"$o->class\"" : "";

	if ($o->pick)
	{ 
          $attr = '<select ' . $name . '>';
          foreach ($o->pick as $item)
    	  {
    	   $attr .= '<option value="' . $item .  '" ' . (($item == $v)?'SELECTED ':'') . $style .'>' . $item . '</option>';
    	  }
    	  $attr .= "</select>";  
	}
	else
	{
    	$type = ' type="' . (is_bool($v) ? 'checkbox' : 'text') . '"';
    	$value = is_bool($v) ? ($v ? ' checked="checked"' : '') : ' value="'.$v.'"';
    	$attr = '<input ' . $type . $style . $class . $name . $value . '/>';
	}
    
	unset($type, $style, $name, $value, $class);
    
	$text = $o->text ? " <span>$o->text</span>" : '';
?>
		<tr>
			<th scope="row"><?php echo $o->title ?></th>
			<td>
				<div style="vertical-align:bottom"><?php echo $attr ?><?php echo $text ?></div>
				<div><em><?php echo $o->help ?></em></div>
			</td>
		</tr>
<?php endforeach ?>
		</table>
	</dd>
</dl>
<?php endforeach ?>

	<p class="submit" align="center">
		<input type="submit" name="submit" value="<?php _e('Save Settings') ?>"  title="This will store the settings to the database." />
		<input type="submit" name="reset" value="<?php _e('Reset Settings') ?>" title="This will remove the settings from the database, giving you the factory defaults"/>
	</p>
</form>

<?php endif // if ($status) ... ?>
</div>
