<?php
/*
Plugin Name: Gallery And Caption
Version: 0.3
Plugin URI: http://www.dyerware.com/main/products/gallery-and-caption
Description: Transparently upgrades your site's native galleries and captions with attractive image viewing and navigation.  Adds caption grouping to create containers of sub-galleries from your posts.   Disabling the plugin will return to the original WordPress behavior.  
Author: dyerware
Author URI: http://www.dyerware.com
*/
/*  Copyright © 2010  dyerware
    Support: support@dyerware.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*
    original jQuery plugin 'zoomimage' by tefan Petre: http://www.eyecon.ro/zoomimage
    Admin panel code lifted (and expanded upon) from Hackadelic TOC plugin.  GREAT design.
*/
  
class wpGalleryAndCaption
{
    private $captionNum = 0;
    private $captionGroupNum = 0;
    private $currentGroup = 0;
    private $currentGroupCaption = 0;
    private $colsPerRow = 3;
    private $installScripts = false;

	// Database Settings
    var $DEF_COLS = 3;
	var $DEF_STYLE = 'galleryAndCaptionContainer';
	var $GBL_SHADOW = 4;
	var $GBL_CENTERED = true;
	var $GBL_CHROME_OPACITY = 0.7;
	var $GBL_BORDER = 1;
	var $GBL_CTRLS_MOUSEOVER = true;
	var $GBL_ZOOMFX = "Tear Away";
	var $GBL_GROUPBUTTON = true;
	var $GBL_SHOWNAV = true;
	
	var $op; 
    
	public function __construct()
    { 
       $jsDir = plugins_url ( plugin_basename ( dirname ( __FILE__ ) ) ) . '/js/';  
       wp_register_script('dyerware-gac_eye', "{$jsDir}eye.compressed.js"); 
       wp_register_script('dyerware-gac_utils', "{$jsDir}utils.compressed.js"); 
       wp_register_script('dyerware-gac_zoomimage', "{$jsDir}zoomimage.compressed.js"); 
       
       $this->init_options_map();
       $this->load_options();
       $this->init_mce_editor_tags();
		
	   if (is_admin()) 
	   {
	        add_action('admin_head', array(&$this,'add_admin_files'));
			add_action('admin_menu', array(&$this, 'add_admin_menu'));
	   }                    
    }

    function init_mce_editor_tags()
    {
       //add_action( 'edit_form_advanced', array(&$this, 'editor_tags'));
	   //add_action( 'edit_page_form', array(&$this, 'editor_tags'));     				
    }
    
    
    function CTXID() 
    { 
        return get_class($this); 
    }


    function add_admin_files() 
    {	       	
    }


	function addCSS() 
	{		
       $cmt = '// <![CDATA[';
       $cmte = '// ]]>';
        			
       if ($this->installScripts)
	   {
	   	echo '<link type="text/css" rel="stylesheet" href="' . plugins_url ( plugin_basename ( dirname ( __FILE__ ) ) ) .'/gallery-and-caption.css" />';	   	   
		echo '<link type="text/css" rel="stylesheet" href="' . plugins_url ( plugin_basename ( dirname ( __FILE__ ) ) ) .'/zoomimage/css/zoomimage.css" />';

        $docenter = 'true';
        if ($this->GBL_CENTERED == false)
        {
            $docenter = 'false';
        }
        
        $dofocus = 'mouseover';
        if ($this->GBL_CTRLS_MOUSEOVER == false)
        {
            $dofocus = 'focus'; 
        }
        
        $shownav = 'true';
        if ($this->GBL_SHOWNAV == false)
        {
            $shownav = 'false';
        }
        
        $dofocus = 'mouseover';
        if ($this->GBL_CTRLS_MOUSEOVER == false)
        {
            $dofocus = 'focus'; 
        }
        
        $zoomeffect =  'hideSource: true,';
        if ($this->GBL_ZOOMFX == 'Tear Away')
        {

        }
        else if ($this->GBL_ZOOMFX == 'Glass Fade')
        {
            $zoomeffect = 'hideSource: false,
            beforeZoomIn: function(boxID) {
				$("#" + boxID)
					.find("img")
					.css("opacity", 0)
					.animate(
						{"opacity":1},
						{ duration: 500, queue: false }
					);
			},
			beforeZoomOut: function(boxID) {
				$("#" + boxID)
					.find("img")
					.css("opacity", 1)
					.animate(
						{"opacity":0},
						{ duration: 500, queue: false }
					);
			},';
        }
    
        echo '
<!-- dyerware Gallery And Caption plugin: www.dyerware.com -->
<script type="text/javascript">
' . $cmt . '
	jQuery(document).ready(function($){
		jQuery(".gallery").each(function(index, obj){
			$(obj).find("a").addClass("galleryAndCaptionItem");
		}); 
				
        jQuery(".galleryAndCaptionItem").zoomimage({
            ' . $zoomeffect . '
            controls: ' . $shownav . ',
            border: ' . $this->GBL_BORDER . ',
            shadow: ' . $this->GBL_SHADOW . ',
            centered: ' . $docenter . ',
            controlsTrigger: "' . $dofocus . '",
            opacity: ' . $this->GBL_CHROME_OPACITY . '
        });
               	
	});	
' . $cmte . '
</script>';	
	   }
	}
 
 	function add_admin_menu() 
 	{
		$title = 'Gallery And Caption';
		add_options_page($title, $title, 10, __FILE__, array(&$this, 'handle_options'));
	}
	
	function init_options_map() 
	{
		$opnames = array(
			'DEF_COLS', 'DEF_STYLE', 'GBL_SHADOW', 'GBL_CENTERED', 'GBL_CHROME_OPACITY', 'GBL_BORDER', 'GBL_CTRLS_MOUSEOVER', 'GBL_ZOOMFX', 'GBL_GROUPBUTTON', 'GBL_SHOWNAV'
		);
		$this->op = (object) array();
		foreach ($opnames as $name)
			$this->op->$name = &$this->$name;
	}
	
	function load_options() 
	{
		$context = $this->CTXID();
		$options = $this->op;
		$saved = get_option($context);
		
		if ($saved) foreach ( (array) $options as $key => $val ) 
		{
			if (!isset($saved->$key)) continue;
			$this->assign_to($options->$key, $saved->$key);
		}
		// Backward compatibility hack, to be removed in a future version
		//$this->migrateOptions($options, $context);
	}
		
	function handle_options() 
	{
		$actionURL = $_SERVER['REQUEST_URI'];
		$context = $this->CTXID();
		$options = $this->op;
		$updated = false;
		$status = '';
		if ( $_POST['action'] == 'update' ):
			check_admin_referer($context);
			if (isset($_POST['submit'])):
				foreach ($options as $key => $val):
					$bistate = is_bool($val);
					if ($bistate):
						$newval = isset($_POST[$key]);
					else:
						if ( !isset($_POST[$key]) ) continue;
						$newval = trim( $_POST[$key] );
					endif;
					if ( $newval == $val ) continue;
					$this->assign_to($options->$key, $newval);
					$updated = true; $status = 'updated';
				endforeach;
				if ($updated): update_option($context, $options); endif;
			elseif (isset($_POST['reset'])):
				delete_option($context);
				$updated = true; $status = 'reset';
			endif;
		endif;
		
		include 'gallery-and-caption-settings.php';
	}
	
	private function assign_to(&$var, $value) 
	{
		settype($value, gettype($var));
		$var = $value;
	}
	
     
    private function translate_numerics(&$value, $key) 
    {   
        if ($value == 'false') {
        	$value = false;
        } elseif ($value == 'true') {
            $value = true;
        }      
    }        
     
    function init_html_editor_tags()
    {
        
        if (is_admin() == true && $this->GBL_GROUPBUTTON == true)
        {    
            echo '<script type="text/javascript">';
?>
if(typeof edButtons!="undefined")
{
edButtons[edButtons.length]=new edButton('dyerware_gac','CaptionGroup','[captiongroup]','[/captiongroup]','i');
}
<?php
            echo '</script>';
        }        
    }
    
    public function output_scripts ()
    {
        if ( is_admin() == true && isset($_GET['page']) && 
            'gallery-and-caption' == $_GET['page']  ) 
        {
            wp_enqueue_script('jquery');  
        }
        else if ($this->installScripts)
        {
            wp_enqueue_script('jquery');
            wp_enqueue_script('dyerware-gac_eye'); 
            wp_enqueue_script('dyerware-gac_utils'); 
            wp_enqueue_script('dyerware-gac_zoomimage'); 
            wp_enqueue_script('dyerware-gac_layout'); 
        } 
    
        $this->init_html_editor_tags();
    }   


	function do_group_shortcode($attr, $content = null) 
	{
	   	$haveIssue = FALSE;
	    $nearKey = "";
	    $nearValue = "";
	    	           
	    if ($atts)
	    {
    	    foreach ($atts as $key => $att)
    	    {
    	       $keyval = (int)$key;
    	       if ($keyval != 0 || strpos($key, "0") === 0)
    	       {
                    $haveIssue = TRUE;
                    $nearKey = $keyval;
                    $nearValue = $att;
                    break;
    	       }
    	    }
	    }

	    if ($haveIssue === TRUE)
	       return "<p><b>Gallery And Caption SHORTCODE ERROR</b><lu><li>Check for misspelled parameters (case matters)</li><li>Check for new lines (all must reside on one long line)</li><li>Error near [" . $key . "], [" . $att . "]</li></lu><br/>For assistance, please visit <a>http://www.dyerware.com/main/products/gallery-and-caption</a></p>";
	   
    	extract(shortcode_atts(array(
    		'columns'	=> $this->DEF_COLS,
    		'groupcss'  => $this->DEF_STYLE,
    	), $attr));
    		   
    
	    // A group has some arguments:
	    $this->colsPerRow = $columns;
	    
        $this->captionGroupNum++; 
        $this->currentGroup = $this->captionGroupNum;
        $this->currentGroupCaption = 0;
                           
        // Bust out our children
        $scontent =  '<pre style="display:none">alksjofaew alsjf </pre><div style="display:none">' . do_shortcode($content);
        
        $end = '</div>';
        if ($this->currentGroupCaption != 0)
        {
            $end = '</tr>';
        }
        
        // ... and reset the group counts
        $this->currentGroup = 0;
        $this->currentGroupCaption = 0;
        
        return '<table class="' . $groupcss . '">' . $scontent . $end . '</table>';
	}
		
		
		
	function do_caption_shortcode($attr, $content = null) 
	{
    	// Allow plugins/themes to override the default caption template.
    	$output = apply_filters('img_caption_shortcode', '', $attr, $content);
    	if ( $output != '' )
    		return $output;
     
    	extract(shortcode_atts(array(
    		'id'	=> '',
    		'align'	=> 'alignnone',
    		'width'	=> '',
    		'caption' => ''
    	), $attr));
     
    	if ( 1 > (int) $width) //|| empty($caption) )
    		return $content;
    		
    	// Extract caption contents.  We ONLY want to add our image behavior to
    	// images we 'own' on the user's behalf.  Once this page is cached, this code
    	// won't run, so no performance concerns.
    	$doc=new DOMDocument(); 
        $doc->loadHTML($content); 
        $xml=simplexml_import_dom($doc); 
        $links=$xml->xpath('//a'); 
        foreach ($links as $a)
        {
            // Class style for zoom
            if ($a['class'])
            {
                $a['class'] = $a['class'] . ' galleryAndCaptionItem';
            }
            else
            {
                $a->addAttribute('class', 'galleryAndCaptionItem');
            }
            
            // Make title part of zoom info
            if ($a['title'])
            {
                $a['title'] = $caption;
            }
            else
            {
                $a->addAttribute('title', $caption);
            }
        }

        if ( $id ) $id = 'id="' . $id . '" ';
     
     	
	    $style = '"width: ' . (10+(int)$width) . 'px;"';
	    $scontent = do_shortcode( $xml->asXML() );
	    	    
 	    // Group features vs standalone
	    if ($this->currentGroup != 0)
	    {  
	       $class = '"wp-caption"';
	       
           if ($this->currentGroupCaption == 0)
           {
                $intro = '<tr>';
           }
           else if (($this->currentGroupCaption % $this->colsPerRow) == 0)
           {
                $intro = '</tr><tr>';
           }
           $this->currentGroupCaption++;
	    }
	    else
	    {
	       $class = '"wp-caption ' . $align . '" ';
	       
	       // Dump and run
	       return '<div ' . $id . ' class=' . $class . ' style=' . $style . '>' . $scontent . '<p class="wp-caption-text">' . $caption . '</p></div>';	       
	    }
	    
	    
        // Complex group organization = 
	    return <<<gacCode
</div>{$intro}<td {$id} class={$class} style={$style}>
{$scontent}<p class="wp-caption-text">{$caption}</p></td>
<div style="display:none">
gacCode;
   }
   
	function parse_attachment( $link, $id ) 
	{
		if ( is_feed() )
			return $link;

		$post = get_post( $id );

		if ( 'image/' == substr( $post->post_mime_type, 0, 6 ) )
		{
		    $ret = wp_get_attachment_url( $id );
		    return $ret;
		}
		else
			return $link;
	}   
	
	public function query_install($posts) 
	{
	    $content = '';
        foreach ($posts as $post) 
        {
            $content .= $post->post_content;
        }
        
        $this->installScripts = (bool)preg_match("/\[gallery(.*)\]/U", $content);
        if ($this->installScripts == false)
        {
            $this->installScripts = (bool)preg_match("/\[caption(.*)\]/U", $content);
            if ($this->installScripts == false)
            {
                $this->installScripts = (bool)preg_match("/\[captiongroup(.*)\]/U", $content);
            }
        }

        return $posts;
	}
}  

// Instantiate our class
$wpGalleryAndCaption= new wpGalleryAndCaption();



/**
 * Add filters and actions
 */

add_action('wp_head', array($wpGalleryAndCaption, 'addCSS'));
add_filter('the_posts', array($wpGalleryAndCaption, 'query_install'));
add_action('wp_print_scripts', array($wpGalleryAndCaption, 'output_scripts'));

add_shortcode('captiongroup',array($wpGalleryAndCaption, 'do_group_shortcode'));
add_shortcode('wp_caption', array($wpGalleryAndCaption, 'do_caption_shortcode'));
add_shortcode('caption', array($wpGalleryAndCaption, 'do_caption_shortcode'));

add_filter('attachment_link', array($wpGalleryAndCaption, 'parse_attachment'), 10, 2 );

?>
